<?php
/**
 * InvoicePaymentTransaction
 *
 * PHP version 7.1+
 *
 * @category Class
 * @package  Killbill\Client\Swagger
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Kill Bill
 *
 * Kill Bill is an open-source billing and payments platform
 *
 * OpenAPI spec version: 0.24.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.22
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Killbill\Client\Swagger\Model;

use \ArrayAccess;
use \Killbill\Client\Swagger\ObjectSerializer;

/**
 * InvoicePaymentTransaction Class Doc Comment
 *
 * @category Class
 * @package  Killbill\Client\Swagger
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class InvoicePaymentTransaction implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'InvoicePaymentTransaction';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'transactionId' => 'string',
'transactionExternalKey' => 'string',
'paymentId' => 'string',
'paymentExternalKey' => 'string',
'transactionType' => 'string',
'amount' => 'float',
'currency' => 'string',
'effectiveDate' => '\DateTime',
'processedAmount' => 'float',
'processedCurrency' => 'string',
'status' => 'string',
'gatewayErrorCode' => 'string',
'gatewayErrorMsg' => 'string',
'firstPaymentReferenceId' => 'string',
'secondPaymentReferenceId' => 'string',
'properties' => '\Killbill\Client\Swagger\Model\PluginProperty[]',
'isAdjusted' => 'bool',
'adjustments' => '\Killbill\Client\Swagger\Model\InvoiceItem[]',
'auditLogs' => '\Killbill\Client\Swagger\Model\AuditLog[]'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'transactionId' => 'uuid',
'transactionExternalKey' => null,
'paymentId' => 'uuid',
'paymentExternalKey' => null,
'transactionType' => null,
'amount' => null,
'currency' => null,
'effectiveDate' => 'date-time',
'processedAmount' => null,
'processedCurrency' => null,
'status' => null,
'gatewayErrorCode' => null,
'gatewayErrorMsg' => null,
'firstPaymentReferenceId' => null,
'secondPaymentReferenceId' => null,
'properties' => null,
'isAdjusted' => null,
'adjustments' => null,
'auditLogs' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes(): array
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats(): array
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'transactionId' => 'transactionId',
'transactionExternalKey' => 'transactionExternalKey',
'paymentId' => 'paymentId',
'paymentExternalKey' => 'paymentExternalKey',
'transactionType' => 'transactionType',
'amount' => 'amount',
'currency' => 'currency',
'effectiveDate' => 'effectiveDate',
'processedAmount' => 'processedAmount',
'processedCurrency' => 'processedCurrency',
'status' => 'status',
'gatewayErrorCode' => 'gatewayErrorCode',
'gatewayErrorMsg' => 'gatewayErrorMsg',
'firstPaymentReferenceId' => 'firstPaymentReferenceId',
'secondPaymentReferenceId' => 'secondPaymentReferenceId',
'properties' => 'properties',
'isAdjusted' => 'isAdjusted',
'adjustments' => 'adjustments',
'auditLogs' => 'auditLogs'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'transactionId' => 'setTransactionId',
'transactionExternalKey' => 'setTransactionExternalKey',
'paymentId' => 'setPaymentId',
'paymentExternalKey' => 'setPaymentExternalKey',
'transactionType' => 'setTransactionType',
'amount' => 'setAmount',
'currency' => 'setCurrency',
'effectiveDate' => 'setEffectiveDate',
'processedAmount' => 'setProcessedAmount',
'processedCurrency' => 'setProcessedCurrency',
'status' => 'setStatus',
'gatewayErrorCode' => 'setGatewayErrorCode',
'gatewayErrorMsg' => 'setGatewayErrorMsg',
'firstPaymentReferenceId' => 'setFirstPaymentReferenceId',
'secondPaymentReferenceId' => 'setSecondPaymentReferenceId',
'properties' => 'setProperties',
'isAdjusted' => 'setIsAdjusted',
'adjustments' => 'setAdjustments',
'auditLogs' => 'setAuditLogs'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'transactionId' => 'getTransactionId',
'transactionExternalKey' => 'getTransactionExternalKey',
'paymentId' => 'getPaymentId',
'paymentExternalKey' => 'getPaymentExternalKey',
'transactionType' => 'getTransactionType',
'amount' => 'getAmount',
'currency' => 'getCurrency',
'effectiveDate' => 'getEffectiveDate',
'processedAmount' => 'getProcessedAmount',
'processedCurrency' => 'getProcessedCurrency',
'status' => 'getStatus',
'gatewayErrorCode' => 'getGatewayErrorCode',
'gatewayErrorMsg' => 'getGatewayErrorMsg',
'firstPaymentReferenceId' => 'getFirstPaymentReferenceId',
'secondPaymentReferenceId' => 'getSecondPaymentReferenceId',
'properties' => 'getProperties',
'isAdjusted' => 'getIsAdjusted',
'adjustments' => 'getAdjustments',
'auditLogs' => 'getAuditLogs'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap(): array
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters(): array
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters(): array
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName(): string
    {
        return self::$swaggerModelName;
    }

    const TRANSACTION_TYPE_AUTHORIZE = 'AUTHORIZE';
const TRANSACTION_TYPE_CAPTURE = 'CAPTURE';
const TRANSACTION_TYPE_CHARGEBACK = 'CHARGEBACK';
const TRANSACTION_TYPE_CREDIT = 'CREDIT';
const TRANSACTION_TYPE_PURCHASE = 'PURCHASE';
const TRANSACTION_TYPE_REFUND = 'REFUND';
const TRANSACTION_TYPE_VOID = 'VOID';
const CURRENCY_AED = 'AED';
const CURRENCY_AFN = 'AFN';
const CURRENCY_ALL = 'ALL';
const CURRENCY_AMD = 'AMD';
const CURRENCY_ANG = 'ANG';
const CURRENCY_AOA = 'AOA';
const CURRENCY_ARS = 'ARS';
const CURRENCY_AUD = 'AUD';
const CURRENCY_AWG = 'AWG';
const CURRENCY_AZN = 'AZN';
const CURRENCY_BAM = 'BAM';
const CURRENCY_BBD = 'BBD';
const CURRENCY_BDT = 'BDT';
const CURRENCY_BGN = 'BGN';
const CURRENCY_BHD = 'BHD';
const CURRENCY_BIF = 'BIF';
const CURRENCY_BMD = 'BMD';
const CURRENCY_BND = 'BND';
const CURRENCY_BOB = 'BOB';
const CURRENCY_BRL = 'BRL';
const CURRENCY_BSD = 'BSD';
const CURRENCY_BTN = 'BTN';
const CURRENCY_BWP = 'BWP';
const CURRENCY_BYR = 'BYR';
const CURRENCY_BZD = 'BZD';
const CURRENCY_CAD = 'CAD';
const CURRENCY_CDF = 'CDF';
const CURRENCY_CHF = 'CHF';
const CURRENCY_CLP = 'CLP';
const CURRENCY_CNY = 'CNY';
const CURRENCY_COP = 'COP';
const CURRENCY_CRC = 'CRC';
const CURRENCY_CUC = 'CUC';
const CURRENCY_CUP = 'CUP';
const CURRENCY_CVE = 'CVE';
const CURRENCY_CZK = 'CZK';
const CURRENCY_DJF = 'DJF';
const CURRENCY_DKK = 'DKK';
const CURRENCY_DOP = 'DOP';
const CURRENCY_DZD = 'DZD';
const CURRENCY_EGP = 'EGP';
const CURRENCY_ERN = 'ERN';
const CURRENCY_ETB = 'ETB';
const CURRENCY_EUR = 'EUR';
const CURRENCY_FJD = 'FJD';
const CURRENCY_FKP = 'FKP';
const CURRENCY_GBP = 'GBP';
const CURRENCY_GEL = 'GEL';
const CURRENCY_GGP = 'GGP';
const CURRENCY_GHS = 'GHS';
const CURRENCY_GIP = 'GIP';
const CURRENCY_GMD = 'GMD';
const CURRENCY_GNF = 'GNF';
const CURRENCY_GTQ = 'GTQ';
const CURRENCY_GYD = 'GYD';
const CURRENCY_HKD = 'HKD';
const CURRENCY_HNL = 'HNL';
const CURRENCY_HRK = 'HRK';
const CURRENCY_HTG = 'HTG';
const CURRENCY_HUF = 'HUF';
const CURRENCY_IDR = 'IDR';
const CURRENCY_ILS = 'ILS';
const CURRENCY_IMP = 'IMP';
const CURRENCY_INR = 'INR';
const CURRENCY_IQD = 'IQD';
const CURRENCY_IRR = 'IRR';
const CURRENCY_ISK = 'ISK';
const CURRENCY_JEP = 'JEP';
const CURRENCY_JMD = 'JMD';
const CURRENCY_JOD = 'JOD';
const CURRENCY_JPY = 'JPY';
const CURRENCY_KES = 'KES';
const CURRENCY_KGS = 'KGS';
const CURRENCY_KHR = 'KHR';
const CURRENCY_KMF = 'KMF';
const CURRENCY_KPW = 'KPW';
const CURRENCY_KRW = 'KRW';
const CURRENCY_KWD = 'KWD';
const CURRENCY_KYD = 'KYD';
const CURRENCY_KZT = 'KZT';
const CURRENCY_LAK = 'LAK';
const CURRENCY_LBP = 'LBP';
const CURRENCY_LKR = 'LKR';
const CURRENCY_LRD = 'LRD';
const CURRENCY_LSL = 'LSL';
const CURRENCY_LTL = 'LTL';
const CURRENCY_LVL = 'LVL';
const CURRENCY_LYD = 'LYD';
const CURRENCY_MAD = 'MAD';
const CURRENCY_MDL = 'MDL';
const CURRENCY_MGA = 'MGA';
const CURRENCY_MKD = 'MKD';
const CURRENCY_MMK = 'MMK';
const CURRENCY_MNT = 'MNT';
const CURRENCY_MOP = 'MOP';
const CURRENCY_MRO = 'MRO';
const CURRENCY_MUR = 'MUR';
const CURRENCY_MVR = 'MVR';
const CURRENCY_MWK = 'MWK';
const CURRENCY_MXN = 'MXN';
const CURRENCY_MYR = 'MYR';
const CURRENCY_MZN = 'MZN';
const CURRENCY_NAD = 'NAD';
const CURRENCY_NGN = 'NGN';
const CURRENCY_NIO = 'NIO';
const CURRENCY_NOK = 'NOK';
const CURRENCY_NPR = 'NPR';
const CURRENCY_NZD = 'NZD';
const CURRENCY_OMR = 'OMR';
const CURRENCY_PAB = 'PAB';
const CURRENCY_PEN = 'PEN';
const CURRENCY_PGK = 'PGK';
const CURRENCY_PHP = 'PHP';
const CURRENCY_PKR = 'PKR';
const CURRENCY_PLN = 'PLN';
const CURRENCY_PYG = 'PYG';
const CURRENCY_QAR = 'QAR';
const CURRENCY_RON = 'RON';
const CURRENCY_RSD = 'RSD';
const CURRENCY_RUB = 'RUB';
const CURRENCY_RWF = 'RWF';
const CURRENCY_SAR = 'SAR';
const CURRENCY_SBD = 'SBD';
const CURRENCY_SCR = 'SCR';
const CURRENCY_SDG = 'SDG';
const CURRENCY_SEK = 'SEK';
const CURRENCY_SGD = 'SGD';
const CURRENCY_SHP = 'SHP';
const CURRENCY_SLL = 'SLL';
const CURRENCY_SOS = 'SOS';
const CURRENCY_SPL = 'SPL';
const CURRENCY_SRD = 'SRD';
const CURRENCY_STD = 'STD';
const CURRENCY_SVC = 'SVC';
const CURRENCY_SYP = 'SYP';
const CURRENCY_SZL = 'SZL';
const CURRENCY_THB = 'THB';
const CURRENCY_TJS = 'TJS';
const CURRENCY_TMT = 'TMT';
const CURRENCY_TND = 'TND';
const CURRENCY_TOP = 'TOP';
const CURRENCY__TRY = 'TRY';
const CURRENCY_TTD = 'TTD';
const CURRENCY_TVD = 'TVD';
const CURRENCY_TWD = 'TWD';
const CURRENCY_TZS = 'TZS';
const CURRENCY_UAH = 'UAH';
const CURRENCY_UGX = 'UGX';
const CURRENCY_USD = 'USD';
const CURRENCY_UYU = 'UYU';
const CURRENCY_UZS = 'UZS';
const CURRENCY_VEF = 'VEF';
const CURRENCY_VND = 'VND';
const CURRENCY_VUV = 'VUV';
const CURRENCY_WST = 'WST';
const CURRENCY_XAF = 'XAF';
const CURRENCY_XCD = 'XCD';
const CURRENCY_XDR = 'XDR';
const CURRENCY_XOF = 'XOF';
const CURRENCY_XPF = 'XPF';
const CURRENCY_YER = 'YER';
const CURRENCY_ZAR = 'ZAR';
const CURRENCY_ZMW = 'ZMW';
const CURRENCY_ZWD = 'ZWD';
const CURRENCY_BTC = 'BTC';
const PROCESSED_CURRENCY_AED = 'AED';
const PROCESSED_CURRENCY_AFN = 'AFN';
const PROCESSED_CURRENCY_ALL = 'ALL';
const PROCESSED_CURRENCY_AMD = 'AMD';
const PROCESSED_CURRENCY_ANG = 'ANG';
const PROCESSED_CURRENCY_AOA = 'AOA';
const PROCESSED_CURRENCY_ARS = 'ARS';
const PROCESSED_CURRENCY_AUD = 'AUD';
const PROCESSED_CURRENCY_AWG = 'AWG';
const PROCESSED_CURRENCY_AZN = 'AZN';
const PROCESSED_CURRENCY_BAM = 'BAM';
const PROCESSED_CURRENCY_BBD = 'BBD';
const PROCESSED_CURRENCY_BDT = 'BDT';
const PROCESSED_CURRENCY_BGN = 'BGN';
const PROCESSED_CURRENCY_BHD = 'BHD';
const PROCESSED_CURRENCY_BIF = 'BIF';
const PROCESSED_CURRENCY_BMD = 'BMD';
const PROCESSED_CURRENCY_BND = 'BND';
const PROCESSED_CURRENCY_BOB = 'BOB';
const PROCESSED_CURRENCY_BRL = 'BRL';
const PROCESSED_CURRENCY_BSD = 'BSD';
const PROCESSED_CURRENCY_BTN = 'BTN';
const PROCESSED_CURRENCY_BWP = 'BWP';
const PROCESSED_CURRENCY_BYR = 'BYR';
const PROCESSED_CURRENCY_BZD = 'BZD';
const PROCESSED_CURRENCY_CAD = 'CAD';
const PROCESSED_CURRENCY_CDF = 'CDF';
const PROCESSED_CURRENCY_CHF = 'CHF';
const PROCESSED_CURRENCY_CLP = 'CLP';
const PROCESSED_CURRENCY_CNY = 'CNY';
const PROCESSED_CURRENCY_COP = 'COP';
const PROCESSED_CURRENCY_CRC = 'CRC';
const PROCESSED_CURRENCY_CUC = 'CUC';
const PROCESSED_CURRENCY_CUP = 'CUP';
const PROCESSED_CURRENCY_CVE = 'CVE';
const PROCESSED_CURRENCY_CZK = 'CZK';
const PROCESSED_CURRENCY_DJF = 'DJF';
const PROCESSED_CURRENCY_DKK = 'DKK';
const PROCESSED_CURRENCY_DOP = 'DOP';
const PROCESSED_CURRENCY_DZD = 'DZD';
const PROCESSED_CURRENCY_EGP = 'EGP';
const PROCESSED_CURRENCY_ERN = 'ERN';
const PROCESSED_CURRENCY_ETB = 'ETB';
const PROCESSED_CURRENCY_EUR = 'EUR';
const PROCESSED_CURRENCY_FJD = 'FJD';
const PROCESSED_CURRENCY_FKP = 'FKP';
const PROCESSED_CURRENCY_GBP = 'GBP';
const PROCESSED_CURRENCY_GEL = 'GEL';
const PROCESSED_CURRENCY_GGP = 'GGP';
const PROCESSED_CURRENCY_GHS = 'GHS';
const PROCESSED_CURRENCY_GIP = 'GIP';
const PROCESSED_CURRENCY_GMD = 'GMD';
const PROCESSED_CURRENCY_GNF = 'GNF';
const PROCESSED_CURRENCY_GTQ = 'GTQ';
const PROCESSED_CURRENCY_GYD = 'GYD';
const PROCESSED_CURRENCY_HKD = 'HKD';
const PROCESSED_CURRENCY_HNL = 'HNL';
const PROCESSED_CURRENCY_HRK = 'HRK';
const PROCESSED_CURRENCY_HTG = 'HTG';
const PROCESSED_CURRENCY_HUF = 'HUF';
const PROCESSED_CURRENCY_IDR = 'IDR';
const PROCESSED_CURRENCY_ILS = 'ILS';
const PROCESSED_CURRENCY_IMP = 'IMP';
const PROCESSED_CURRENCY_INR = 'INR';
const PROCESSED_CURRENCY_IQD = 'IQD';
const PROCESSED_CURRENCY_IRR = 'IRR';
const PROCESSED_CURRENCY_ISK = 'ISK';
const PROCESSED_CURRENCY_JEP = 'JEP';
const PROCESSED_CURRENCY_JMD = 'JMD';
const PROCESSED_CURRENCY_JOD = 'JOD';
const PROCESSED_CURRENCY_JPY = 'JPY';
const PROCESSED_CURRENCY_KES = 'KES';
const PROCESSED_CURRENCY_KGS = 'KGS';
const PROCESSED_CURRENCY_KHR = 'KHR';
const PROCESSED_CURRENCY_KMF = 'KMF';
const PROCESSED_CURRENCY_KPW = 'KPW';
const PROCESSED_CURRENCY_KRW = 'KRW';
const PROCESSED_CURRENCY_KWD = 'KWD';
const PROCESSED_CURRENCY_KYD = 'KYD';
const PROCESSED_CURRENCY_KZT = 'KZT';
const PROCESSED_CURRENCY_LAK = 'LAK';
const PROCESSED_CURRENCY_LBP = 'LBP';
const PROCESSED_CURRENCY_LKR = 'LKR';
const PROCESSED_CURRENCY_LRD = 'LRD';
const PROCESSED_CURRENCY_LSL = 'LSL';
const PROCESSED_CURRENCY_LTL = 'LTL';
const PROCESSED_CURRENCY_LVL = 'LVL';
const PROCESSED_CURRENCY_LYD = 'LYD';
const PROCESSED_CURRENCY_MAD = 'MAD';
const PROCESSED_CURRENCY_MDL = 'MDL';
const PROCESSED_CURRENCY_MGA = 'MGA';
const PROCESSED_CURRENCY_MKD = 'MKD';
const PROCESSED_CURRENCY_MMK = 'MMK';
const PROCESSED_CURRENCY_MNT = 'MNT';
const PROCESSED_CURRENCY_MOP = 'MOP';
const PROCESSED_CURRENCY_MRO = 'MRO';
const PROCESSED_CURRENCY_MUR = 'MUR';
const PROCESSED_CURRENCY_MVR = 'MVR';
const PROCESSED_CURRENCY_MWK = 'MWK';
const PROCESSED_CURRENCY_MXN = 'MXN';
const PROCESSED_CURRENCY_MYR = 'MYR';
const PROCESSED_CURRENCY_MZN = 'MZN';
const PROCESSED_CURRENCY_NAD = 'NAD';
const PROCESSED_CURRENCY_NGN = 'NGN';
const PROCESSED_CURRENCY_NIO = 'NIO';
const PROCESSED_CURRENCY_NOK = 'NOK';
const PROCESSED_CURRENCY_NPR = 'NPR';
const PROCESSED_CURRENCY_NZD = 'NZD';
const PROCESSED_CURRENCY_OMR = 'OMR';
const PROCESSED_CURRENCY_PAB = 'PAB';
const PROCESSED_CURRENCY_PEN = 'PEN';
const PROCESSED_CURRENCY_PGK = 'PGK';
const PROCESSED_CURRENCY_PHP = 'PHP';
const PROCESSED_CURRENCY_PKR = 'PKR';
const PROCESSED_CURRENCY_PLN = 'PLN';
const PROCESSED_CURRENCY_PYG = 'PYG';
const PROCESSED_CURRENCY_QAR = 'QAR';
const PROCESSED_CURRENCY_RON = 'RON';
const PROCESSED_CURRENCY_RSD = 'RSD';
const PROCESSED_CURRENCY_RUB = 'RUB';
const PROCESSED_CURRENCY_RWF = 'RWF';
const PROCESSED_CURRENCY_SAR = 'SAR';
const PROCESSED_CURRENCY_SBD = 'SBD';
const PROCESSED_CURRENCY_SCR = 'SCR';
const PROCESSED_CURRENCY_SDG = 'SDG';
const PROCESSED_CURRENCY_SEK = 'SEK';
const PROCESSED_CURRENCY_SGD = 'SGD';
const PROCESSED_CURRENCY_SHP = 'SHP';
const PROCESSED_CURRENCY_SLL = 'SLL';
const PROCESSED_CURRENCY_SOS = 'SOS';
const PROCESSED_CURRENCY_SPL = 'SPL';
const PROCESSED_CURRENCY_SRD = 'SRD';
const PROCESSED_CURRENCY_STD = 'STD';
const PROCESSED_CURRENCY_SVC = 'SVC';
const PROCESSED_CURRENCY_SYP = 'SYP';
const PROCESSED_CURRENCY_SZL = 'SZL';
const PROCESSED_CURRENCY_THB = 'THB';
const PROCESSED_CURRENCY_TJS = 'TJS';
const PROCESSED_CURRENCY_TMT = 'TMT';
const PROCESSED_CURRENCY_TND = 'TND';
const PROCESSED_CURRENCY_TOP = 'TOP';
const PROCESSED_CURRENCY__TRY = 'TRY';
const PROCESSED_CURRENCY_TTD = 'TTD';
const PROCESSED_CURRENCY_TVD = 'TVD';
const PROCESSED_CURRENCY_TWD = 'TWD';
const PROCESSED_CURRENCY_TZS = 'TZS';
const PROCESSED_CURRENCY_UAH = 'UAH';
const PROCESSED_CURRENCY_UGX = 'UGX';
const PROCESSED_CURRENCY_USD = 'USD';
const PROCESSED_CURRENCY_UYU = 'UYU';
const PROCESSED_CURRENCY_UZS = 'UZS';
const PROCESSED_CURRENCY_VEF = 'VEF';
const PROCESSED_CURRENCY_VND = 'VND';
const PROCESSED_CURRENCY_VUV = 'VUV';
const PROCESSED_CURRENCY_WST = 'WST';
const PROCESSED_CURRENCY_XAF = 'XAF';
const PROCESSED_CURRENCY_XCD = 'XCD';
const PROCESSED_CURRENCY_XDR = 'XDR';
const PROCESSED_CURRENCY_XOF = 'XOF';
const PROCESSED_CURRENCY_XPF = 'XPF';
const PROCESSED_CURRENCY_YER = 'YER';
const PROCESSED_CURRENCY_ZAR = 'ZAR';
const PROCESSED_CURRENCY_ZMW = 'ZMW';
const PROCESSED_CURRENCY_ZWD = 'ZWD';
const PROCESSED_CURRENCY_BTC = 'BTC';
const STATUS_SUCCESS = 'SUCCESS';
const STATUS_UNKNOWN = 'UNKNOWN';
const STATUS_PENDING = 'PENDING';
const STATUS_PAYMENT_FAILURE = 'PAYMENT_FAILURE';
const STATUS_PLUGIN_FAILURE = 'PLUGIN_FAILURE';
const STATUS_PAYMENT_SYSTEM_OFF = 'PAYMENT_SYSTEM_OFF';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getTransactionTypeAllowableValues(): array
    {
        return [
            self::TRANSACTION_TYPE_AUTHORIZE,
self::TRANSACTION_TYPE_CAPTURE,
self::TRANSACTION_TYPE_CHARGEBACK,
self::TRANSACTION_TYPE_CREDIT,
self::TRANSACTION_TYPE_PURCHASE,
self::TRANSACTION_TYPE_REFUND,
self::TRANSACTION_TYPE_VOID,        ];
    }
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getCurrencyAllowableValues(): array
    {
        return [
            self::CURRENCY_AED,
self::CURRENCY_AFN,
self::CURRENCY_ALL,
self::CURRENCY_AMD,
self::CURRENCY_ANG,
self::CURRENCY_AOA,
self::CURRENCY_ARS,
self::CURRENCY_AUD,
self::CURRENCY_AWG,
self::CURRENCY_AZN,
self::CURRENCY_BAM,
self::CURRENCY_BBD,
self::CURRENCY_BDT,
self::CURRENCY_BGN,
self::CURRENCY_BHD,
self::CURRENCY_BIF,
self::CURRENCY_BMD,
self::CURRENCY_BND,
self::CURRENCY_BOB,
self::CURRENCY_BRL,
self::CURRENCY_BSD,
self::CURRENCY_BTN,
self::CURRENCY_BWP,
self::CURRENCY_BYR,
self::CURRENCY_BZD,
self::CURRENCY_CAD,
self::CURRENCY_CDF,
self::CURRENCY_CHF,
self::CURRENCY_CLP,
self::CURRENCY_CNY,
self::CURRENCY_COP,
self::CURRENCY_CRC,
self::CURRENCY_CUC,
self::CURRENCY_CUP,
self::CURRENCY_CVE,
self::CURRENCY_CZK,
self::CURRENCY_DJF,
self::CURRENCY_DKK,
self::CURRENCY_DOP,
self::CURRENCY_DZD,
self::CURRENCY_EGP,
self::CURRENCY_ERN,
self::CURRENCY_ETB,
self::CURRENCY_EUR,
self::CURRENCY_FJD,
self::CURRENCY_FKP,
self::CURRENCY_GBP,
self::CURRENCY_GEL,
self::CURRENCY_GGP,
self::CURRENCY_GHS,
self::CURRENCY_GIP,
self::CURRENCY_GMD,
self::CURRENCY_GNF,
self::CURRENCY_GTQ,
self::CURRENCY_GYD,
self::CURRENCY_HKD,
self::CURRENCY_HNL,
self::CURRENCY_HRK,
self::CURRENCY_HTG,
self::CURRENCY_HUF,
self::CURRENCY_IDR,
self::CURRENCY_ILS,
self::CURRENCY_IMP,
self::CURRENCY_INR,
self::CURRENCY_IQD,
self::CURRENCY_IRR,
self::CURRENCY_ISK,
self::CURRENCY_JEP,
self::CURRENCY_JMD,
self::CURRENCY_JOD,
self::CURRENCY_JPY,
self::CURRENCY_KES,
self::CURRENCY_KGS,
self::CURRENCY_KHR,
self::CURRENCY_KMF,
self::CURRENCY_KPW,
self::CURRENCY_KRW,
self::CURRENCY_KWD,
self::CURRENCY_KYD,
self::CURRENCY_KZT,
self::CURRENCY_LAK,
self::CURRENCY_LBP,
self::CURRENCY_LKR,
self::CURRENCY_LRD,
self::CURRENCY_LSL,
self::CURRENCY_LTL,
self::CURRENCY_LVL,
self::CURRENCY_LYD,
self::CURRENCY_MAD,
self::CURRENCY_MDL,
self::CURRENCY_MGA,
self::CURRENCY_MKD,
self::CURRENCY_MMK,
self::CURRENCY_MNT,
self::CURRENCY_MOP,
self::CURRENCY_MRO,
self::CURRENCY_MUR,
self::CURRENCY_MVR,
self::CURRENCY_MWK,
self::CURRENCY_MXN,
self::CURRENCY_MYR,
self::CURRENCY_MZN,
self::CURRENCY_NAD,
self::CURRENCY_NGN,
self::CURRENCY_NIO,
self::CURRENCY_NOK,
self::CURRENCY_NPR,
self::CURRENCY_NZD,
self::CURRENCY_OMR,
self::CURRENCY_PAB,
self::CURRENCY_PEN,
self::CURRENCY_PGK,
self::CURRENCY_PHP,
self::CURRENCY_PKR,
self::CURRENCY_PLN,
self::CURRENCY_PYG,
self::CURRENCY_QAR,
self::CURRENCY_RON,
self::CURRENCY_RSD,
self::CURRENCY_RUB,
self::CURRENCY_RWF,
self::CURRENCY_SAR,
self::CURRENCY_SBD,
self::CURRENCY_SCR,
self::CURRENCY_SDG,
self::CURRENCY_SEK,
self::CURRENCY_SGD,
self::CURRENCY_SHP,
self::CURRENCY_SLL,
self::CURRENCY_SOS,
self::CURRENCY_SPL,
self::CURRENCY_SRD,
self::CURRENCY_STD,
self::CURRENCY_SVC,
self::CURRENCY_SYP,
self::CURRENCY_SZL,
self::CURRENCY_THB,
self::CURRENCY_TJS,
self::CURRENCY_TMT,
self::CURRENCY_TND,
self::CURRENCY_TOP,
self::CURRENCY__TRY,
self::CURRENCY_TTD,
self::CURRENCY_TVD,
self::CURRENCY_TWD,
self::CURRENCY_TZS,
self::CURRENCY_UAH,
self::CURRENCY_UGX,
self::CURRENCY_USD,
self::CURRENCY_UYU,
self::CURRENCY_UZS,
self::CURRENCY_VEF,
self::CURRENCY_VND,
self::CURRENCY_VUV,
self::CURRENCY_WST,
self::CURRENCY_XAF,
self::CURRENCY_XCD,
self::CURRENCY_XDR,
self::CURRENCY_XOF,
self::CURRENCY_XPF,
self::CURRENCY_YER,
self::CURRENCY_ZAR,
self::CURRENCY_ZMW,
self::CURRENCY_ZWD,
self::CURRENCY_BTC,        ];
    }
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getProcessedCurrencyAllowableValues(): array
    {
        return [
            self::PROCESSED_CURRENCY_AED,
self::PROCESSED_CURRENCY_AFN,
self::PROCESSED_CURRENCY_ALL,
self::PROCESSED_CURRENCY_AMD,
self::PROCESSED_CURRENCY_ANG,
self::PROCESSED_CURRENCY_AOA,
self::PROCESSED_CURRENCY_ARS,
self::PROCESSED_CURRENCY_AUD,
self::PROCESSED_CURRENCY_AWG,
self::PROCESSED_CURRENCY_AZN,
self::PROCESSED_CURRENCY_BAM,
self::PROCESSED_CURRENCY_BBD,
self::PROCESSED_CURRENCY_BDT,
self::PROCESSED_CURRENCY_BGN,
self::PROCESSED_CURRENCY_BHD,
self::PROCESSED_CURRENCY_BIF,
self::PROCESSED_CURRENCY_BMD,
self::PROCESSED_CURRENCY_BND,
self::PROCESSED_CURRENCY_BOB,
self::PROCESSED_CURRENCY_BRL,
self::PROCESSED_CURRENCY_BSD,
self::PROCESSED_CURRENCY_BTN,
self::PROCESSED_CURRENCY_BWP,
self::PROCESSED_CURRENCY_BYR,
self::PROCESSED_CURRENCY_BZD,
self::PROCESSED_CURRENCY_CAD,
self::PROCESSED_CURRENCY_CDF,
self::PROCESSED_CURRENCY_CHF,
self::PROCESSED_CURRENCY_CLP,
self::PROCESSED_CURRENCY_CNY,
self::PROCESSED_CURRENCY_COP,
self::PROCESSED_CURRENCY_CRC,
self::PROCESSED_CURRENCY_CUC,
self::PROCESSED_CURRENCY_CUP,
self::PROCESSED_CURRENCY_CVE,
self::PROCESSED_CURRENCY_CZK,
self::PROCESSED_CURRENCY_DJF,
self::PROCESSED_CURRENCY_DKK,
self::PROCESSED_CURRENCY_DOP,
self::PROCESSED_CURRENCY_DZD,
self::PROCESSED_CURRENCY_EGP,
self::PROCESSED_CURRENCY_ERN,
self::PROCESSED_CURRENCY_ETB,
self::PROCESSED_CURRENCY_EUR,
self::PROCESSED_CURRENCY_FJD,
self::PROCESSED_CURRENCY_FKP,
self::PROCESSED_CURRENCY_GBP,
self::PROCESSED_CURRENCY_GEL,
self::PROCESSED_CURRENCY_GGP,
self::PROCESSED_CURRENCY_GHS,
self::PROCESSED_CURRENCY_GIP,
self::PROCESSED_CURRENCY_GMD,
self::PROCESSED_CURRENCY_GNF,
self::PROCESSED_CURRENCY_GTQ,
self::PROCESSED_CURRENCY_GYD,
self::PROCESSED_CURRENCY_HKD,
self::PROCESSED_CURRENCY_HNL,
self::PROCESSED_CURRENCY_HRK,
self::PROCESSED_CURRENCY_HTG,
self::PROCESSED_CURRENCY_HUF,
self::PROCESSED_CURRENCY_IDR,
self::PROCESSED_CURRENCY_ILS,
self::PROCESSED_CURRENCY_IMP,
self::PROCESSED_CURRENCY_INR,
self::PROCESSED_CURRENCY_IQD,
self::PROCESSED_CURRENCY_IRR,
self::PROCESSED_CURRENCY_ISK,
self::PROCESSED_CURRENCY_JEP,
self::PROCESSED_CURRENCY_JMD,
self::PROCESSED_CURRENCY_JOD,
self::PROCESSED_CURRENCY_JPY,
self::PROCESSED_CURRENCY_KES,
self::PROCESSED_CURRENCY_KGS,
self::PROCESSED_CURRENCY_KHR,
self::PROCESSED_CURRENCY_KMF,
self::PROCESSED_CURRENCY_KPW,
self::PROCESSED_CURRENCY_KRW,
self::PROCESSED_CURRENCY_KWD,
self::PROCESSED_CURRENCY_KYD,
self::PROCESSED_CURRENCY_KZT,
self::PROCESSED_CURRENCY_LAK,
self::PROCESSED_CURRENCY_LBP,
self::PROCESSED_CURRENCY_LKR,
self::PROCESSED_CURRENCY_LRD,
self::PROCESSED_CURRENCY_LSL,
self::PROCESSED_CURRENCY_LTL,
self::PROCESSED_CURRENCY_LVL,
self::PROCESSED_CURRENCY_LYD,
self::PROCESSED_CURRENCY_MAD,
self::PROCESSED_CURRENCY_MDL,
self::PROCESSED_CURRENCY_MGA,
self::PROCESSED_CURRENCY_MKD,
self::PROCESSED_CURRENCY_MMK,
self::PROCESSED_CURRENCY_MNT,
self::PROCESSED_CURRENCY_MOP,
self::PROCESSED_CURRENCY_MRO,
self::PROCESSED_CURRENCY_MUR,
self::PROCESSED_CURRENCY_MVR,
self::PROCESSED_CURRENCY_MWK,
self::PROCESSED_CURRENCY_MXN,
self::PROCESSED_CURRENCY_MYR,
self::PROCESSED_CURRENCY_MZN,
self::PROCESSED_CURRENCY_NAD,
self::PROCESSED_CURRENCY_NGN,
self::PROCESSED_CURRENCY_NIO,
self::PROCESSED_CURRENCY_NOK,
self::PROCESSED_CURRENCY_NPR,
self::PROCESSED_CURRENCY_NZD,
self::PROCESSED_CURRENCY_OMR,
self::PROCESSED_CURRENCY_PAB,
self::PROCESSED_CURRENCY_PEN,
self::PROCESSED_CURRENCY_PGK,
self::PROCESSED_CURRENCY_PHP,
self::PROCESSED_CURRENCY_PKR,
self::PROCESSED_CURRENCY_PLN,
self::PROCESSED_CURRENCY_PYG,
self::PROCESSED_CURRENCY_QAR,
self::PROCESSED_CURRENCY_RON,
self::PROCESSED_CURRENCY_RSD,
self::PROCESSED_CURRENCY_RUB,
self::PROCESSED_CURRENCY_RWF,
self::PROCESSED_CURRENCY_SAR,
self::PROCESSED_CURRENCY_SBD,
self::PROCESSED_CURRENCY_SCR,
self::PROCESSED_CURRENCY_SDG,
self::PROCESSED_CURRENCY_SEK,
self::PROCESSED_CURRENCY_SGD,
self::PROCESSED_CURRENCY_SHP,
self::PROCESSED_CURRENCY_SLL,
self::PROCESSED_CURRENCY_SOS,
self::PROCESSED_CURRENCY_SPL,
self::PROCESSED_CURRENCY_SRD,
self::PROCESSED_CURRENCY_STD,
self::PROCESSED_CURRENCY_SVC,
self::PROCESSED_CURRENCY_SYP,
self::PROCESSED_CURRENCY_SZL,
self::PROCESSED_CURRENCY_THB,
self::PROCESSED_CURRENCY_TJS,
self::PROCESSED_CURRENCY_TMT,
self::PROCESSED_CURRENCY_TND,
self::PROCESSED_CURRENCY_TOP,
self::PROCESSED_CURRENCY__TRY,
self::PROCESSED_CURRENCY_TTD,
self::PROCESSED_CURRENCY_TVD,
self::PROCESSED_CURRENCY_TWD,
self::PROCESSED_CURRENCY_TZS,
self::PROCESSED_CURRENCY_UAH,
self::PROCESSED_CURRENCY_UGX,
self::PROCESSED_CURRENCY_USD,
self::PROCESSED_CURRENCY_UYU,
self::PROCESSED_CURRENCY_UZS,
self::PROCESSED_CURRENCY_VEF,
self::PROCESSED_CURRENCY_VND,
self::PROCESSED_CURRENCY_VUV,
self::PROCESSED_CURRENCY_WST,
self::PROCESSED_CURRENCY_XAF,
self::PROCESSED_CURRENCY_XCD,
self::PROCESSED_CURRENCY_XDR,
self::PROCESSED_CURRENCY_XOF,
self::PROCESSED_CURRENCY_XPF,
self::PROCESSED_CURRENCY_YER,
self::PROCESSED_CURRENCY_ZAR,
self::PROCESSED_CURRENCY_ZMW,
self::PROCESSED_CURRENCY_ZWD,
self::PROCESSED_CURRENCY_BTC,        ];
    }
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues(): array
    {
        return [
            self::STATUS_SUCCESS,
self::STATUS_UNKNOWN,
self::STATUS_PENDING,
self::STATUS_PAYMENT_FAILURE,
self::STATUS_PLUGIN_FAILURE,
self::STATUS_PAYMENT_SYSTEM_OFF,        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['transactionId'] = isset($data['transactionId']) ? $data['transactionId'] : null;
        $this->container['transactionExternalKey'] = isset($data['transactionExternalKey']) ? $data['transactionExternalKey'] : null;
        $this->container['paymentId'] = isset($data['paymentId']) ? $data['paymentId'] : null;
        $this->container['paymentExternalKey'] = isset($data['paymentExternalKey']) ? $data['paymentExternalKey'] : null;
        $this->container['transactionType'] = isset($data['transactionType']) ? $data['transactionType'] : null;
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['currency'] = isset($data['currency']) ? $data['currency'] : null;
        $this->container['effectiveDate'] = isset($data['effectiveDate']) ? $data['effectiveDate'] : null;
        $this->container['processedAmount'] = isset($data['processedAmount']) ? $data['processedAmount'] : null;
        $this->container['processedCurrency'] = isset($data['processedCurrency']) ? $data['processedCurrency'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['gatewayErrorCode'] = isset($data['gatewayErrorCode']) ? $data['gatewayErrorCode'] : null;
        $this->container['gatewayErrorMsg'] = isset($data['gatewayErrorMsg']) ? $data['gatewayErrorMsg'] : null;
        $this->container['firstPaymentReferenceId'] = isset($data['firstPaymentReferenceId']) ? $data['firstPaymentReferenceId'] : null;
        $this->container['secondPaymentReferenceId'] = isset($data['secondPaymentReferenceId']) ? $data['secondPaymentReferenceId'] : null;
        $this->container['properties'] = isset($data['properties']) ? $data['properties'] : null;
        $this->container['isAdjusted'] = isset($data['isAdjusted']) ? $data['isAdjusted'] : null;
        $this->container['adjustments'] = isset($data['adjustments']) ? $data['adjustments'] : null;
        $this->container['auditLogs'] = isset($data['auditLogs']) ? $data['auditLogs'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties(): array
    {
        $invalidProperties = [];

        $allowedValues = $this->getTransactionTypeAllowableValues();
        if (!is_null($this->container['transactionType']) && !in_array($this->container['transactionType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'transactionType', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getCurrencyAllowableValues();
        if (!is_null($this->container['currency']) && !in_array($this->container['currency'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'currency', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getProcessedCurrencyAllowableValues();
        if (!is_null($this->container['processedCurrency']) && !in_array($this->container['processedCurrency'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'processedCurrency', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getStatusAllowableValues();
        if (!is_null($this->container['status']) && !in_array($this->container['status'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'status', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid(): bool
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets transactionId
     *
     * @return string
     */
    public function getTransactionId()
    {
        return $this->container['transactionId'];
    }

    /**
     * Sets transactionId
     *
     * @param string $transactionId transactionId
     *
     * @return $this
     */
    public function setTransactionId($transactionId): InvoicePaymentTransaction
    {
        $this->container['transactionId'] = $transactionId;

        return $this;
    }

    /**
     * Gets transactionExternalKey
     *
     * @return string
     */
    public function getTransactionExternalKey()
    {
        return $this->container['transactionExternalKey'];
    }

    /**
     * Sets transactionExternalKey
     *
     * @param string $transactionExternalKey transactionExternalKey
     *
     * @return $this
     */
    public function setTransactionExternalKey($transactionExternalKey): InvoicePaymentTransaction
    {
        $this->container['transactionExternalKey'] = $transactionExternalKey;

        return $this;
    }

    /**
     * Gets paymentId
     *
     * @return string
     */
    public function getPaymentId()
    {
        return $this->container['paymentId'];
    }

    /**
     * Sets paymentId
     *
     * @param string $paymentId Associated payment id, required when notifying state transitions
     *
     * @return $this
     */
    public function setPaymentId($paymentId): InvoicePaymentTransaction
    {
        $this->container['paymentId'] = $paymentId;

        return $this;
    }

    /**
     * Gets paymentExternalKey
     *
     * @return string
     */
    public function getPaymentExternalKey()
    {
        return $this->container['paymentExternalKey'];
    }

    /**
     * Sets paymentExternalKey
     *
     * @param string $paymentExternalKey paymentExternalKey
     *
     * @return $this
     */
    public function setPaymentExternalKey($paymentExternalKey): InvoicePaymentTransaction
    {
        $this->container['paymentExternalKey'] = $paymentExternalKey;

        return $this;
    }

    /**
     * Gets transactionType
     *
     * @return string
     */
    public function getTransactionType()
    {
        return $this->container['transactionType'];
    }

    /**
     * Sets transactionType
     *
     * @param string $transactionType transactionType
     *
     * @return $this
     */
    public function setTransactionType($transactionType): InvoicePaymentTransaction
    {
        $allowedValues = $this->getTransactionTypeAllowableValues();
        if (!is_null($transactionType) && !in_array($transactionType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'transactionType', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['transactionType'] = $transactionType;

        return $this;
    }

    /**
     * Gets amount
     *
     * @return float
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     *
     * @param float $amount Transaction amount, required except for void operations
     *
     * @return $this
     */
    public function setAmount($amount): InvoicePaymentTransaction
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets currency
     *
     * @return string
     */
    public function getCurrency()
    {
        return $this->container['currency'];
    }

    /**
     * Sets currency
     *
     * @param string $currency Amount currency (account currency unless specified)
     *
     * @return $this
     */
    public function setCurrency($currency): InvoicePaymentTransaction
    {
        $allowedValues = $this->getCurrencyAllowableValues();
        if (!is_null($currency) && !in_array($currency, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'currency', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['currency'] = $currency;

        return $this;
    }

    /**
     * Gets effectiveDate
     *
     * @return \DateTime
     */
    public function getEffectiveDate()
    {
        return $this->container['effectiveDate'];
    }

    /**
     * Sets effectiveDate
     *
     * @param \DateTime $effectiveDate effectiveDate
     *
     * @return $this
     */
    public function setEffectiveDate($effectiveDate): InvoicePaymentTransaction
    {
        $this->container['effectiveDate'] = $effectiveDate;

        return $this;
    }

    /**
     * Gets processedAmount
     *
     * @return float
     */
    public function getProcessedAmount()
    {
        return $this->container['processedAmount'];
    }

    /**
     * Sets processedAmount
     *
     * @param float $processedAmount processedAmount
     *
     * @return $this
     */
    public function setProcessedAmount($processedAmount): InvoicePaymentTransaction
    {
        $this->container['processedAmount'] = $processedAmount;

        return $this;
    }

    /**
     * Gets processedCurrency
     *
     * @return string
     */
    public function getProcessedCurrency()
    {
        return $this->container['processedCurrency'];
    }

    /**
     * Sets processedCurrency
     *
     * @param string $processedCurrency processedCurrency
     *
     * @return $this
     */
    public function setProcessedCurrency($processedCurrency): InvoicePaymentTransaction
    {
        $allowedValues = $this->getProcessedCurrencyAllowableValues();
        if (!is_null($processedCurrency) && !in_array($processedCurrency, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'processedCurrency', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['processedCurrency'] = $processedCurrency;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status Transaction status, required for state change notifications
     *
     * @return $this
     */
    public function setStatus($status): InvoicePaymentTransaction
    {
        $allowedValues = $this->getStatusAllowableValues();
        if (!is_null($status) && !in_array($status, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'status', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets gatewayErrorCode
     *
     * @return string
     */
    public function getGatewayErrorCode()
    {
        return $this->container['gatewayErrorCode'];
    }

    /**
     * Sets gatewayErrorCode
     *
     * @param string $gatewayErrorCode gatewayErrorCode
     *
     * @return $this
     */
    public function setGatewayErrorCode($gatewayErrorCode): InvoicePaymentTransaction
    {
        $this->container['gatewayErrorCode'] = $gatewayErrorCode;

        return $this;
    }

    /**
     * Gets gatewayErrorMsg
     *
     * @return string
     */
    public function getGatewayErrorMsg()
    {
        return $this->container['gatewayErrorMsg'];
    }

    /**
     * Sets gatewayErrorMsg
     *
     * @param string $gatewayErrorMsg gatewayErrorMsg
     *
     * @return $this
     */
    public function setGatewayErrorMsg($gatewayErrorMsg): InvoicePaymentTransaction
    {
        $this->container['gatewayErrorMsg'] = $gatewayErrorMsg;

        return $this;
    }

    /**
     * Gets firstPaymentReferenceId
     *
     * @return string
     */
    public function getFirstPaymentReferenceId()
    {
        return $this->container['firstPaymentReferenceId'];
    }

    /**
     * Sets firstPaymentReferenceId
     *
     * @param string $firstPaymentReferenceId firstPaymentReferenceId
     *
     * @return $this
     */
    public function setFirstPaymentReferenceId($firstPaymentReferenceId): InvoicePaymentTransaction
    {
        $this->container['firstPaymentReferenceId'] = $firstPaymentReferenceId;

        return $this;
    }

    /**
     * Gets secondPaymentReferenceId
     *
     * @return string
     */
    public function getSecondPaymentReferenceId()
    {
        return $this->container['secondPaymentReferenceId'];
    }

    /**
     * Sets secondPaymentReferenceId
     *
     * @param string $secondPaymentReferenceId secondPaymentReferenceId
     *
     * @return $this
     */
    public function setSecondPaymentReferenceId($secondPaymentReferenceId): InvoicePaymentTransaction
    {
        $this->container['secondPaymentReferenceId'] = $secondPaymentReferenceId;

        return $this;
    }

    /**
     * Gets properties
     *
     * @return \Killbill\Client\Swagger\Model\PluginProperty[]
     */
    public function getProperties()
    {
        return $this->container['properties'];
    }

    /**
     * Sets properties
     *
     * @param \Killbill\Client\Swagger\Model\PluginProperty[] $properties properties
     *
     * @return $this
     */
    public function setProperties($properties): InvoicePaymentTransaction
    {
        $this->container['properties'] = $properties;

        return $this;
    }

    /**
     * Gets isAdjusted
     *
     * @return bool
     */
    public function getIsAdjusted()
    {
        return $this->container['isAdjusted'];
    }

    /**
     * Sets isAdjusted
     *
     * @param bool $isAdjusted isAdjusted
     *
     * @return $this
     */
    public function setIsAdjusted($isAdjusted): InvoicePaymentTransaction
    {
        $this->container['isAdjusted'] = $isAdjusted;

        return $this;
    }

    /**
     * Gets adjustments
     *
     * @return \Killbill\Client\Swagger\Model\InvoiceItem[]
     */
    public function getAdjustments()
    {
        return $this->container['adjustments'];
    }

    /**
     * Sets adjustments
     *
     * @param \Killbill\Client\Swagger\Model\InvoiceItem[] $adjustments adjustments
     *
     * @return $this
     */
    public function setAdjustments($adjustments): InvoicePaymentTransaction
    {
        $this->container['adjustments'] = $adjustments;

        return $this;
    }

    /**
     * Gets auditLogs
     *
     * @return \Killbill\Client\Swagger\Model\AuditLog[]
     */
    public function getAuditLogs()
    {
        return $this->container['auditLogs'];
    }

    /**
     * Sets auditLogs
     *
     * @param \Killbill\Client\Swagger\Model\AuditLog[] $auditLogs auditLogs
     *
     * @return $this
     */
    public function setAuditLogs($auditLogs): InvoicePaymentTransaction
    {
        $this->container['auditLogs'] = $auditLogs;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return bool
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString(): string
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
